#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long int n,k,s=0,j=0;
    scanf ("%lld",&n);
    scanf ("%lld",&k);
    long long int a[n];
    for(long long int i=0; i<n; i++)
    {
        scanf ("%lld",&a[i]);
    }
    long long int b[2*n+1]={0};
    long long int x[2*n+1]={0};
    for(long long int i=0; i<n; i++)
    {
        if(a[i]<=0)
        b[-a[i]]++;
        else
            b[n+a[i]]++;
    }
    for(long long int i=0; i<2*n+1; i++)
    {
        if(b[i]>=k)
        {
            s++;
            if(i<=n)
            x[j]=-i;
            else
                x[j]=i-n;
            j++;
        }
    }
    cout << s << endl;
    for(long long int i=0; i<j; i++)
    {
        printf ("%lld ",x[i]);
    }
    return 0;
}